<template>
	<div>
		<q-card class="cardPadding" flat square bordered :style="generateStyle">
			<q-card-section v-if="(room.firstname && roomSettings.patient) || roomSettings.roomNumber">
				<div class="row items-center no-wrap">
					<div class="col" v-if="roomSettings.roomNumber">
						<div class="title">{{this.roomId}}</div>
					</div>

					<div class="col-auto">
						<div class="text-center" style="padding: 4px;" v-if="room.firstname && roomSettings.patient">
							<q-btn
								:dense="roomSettings.dense"
								round
								size="xs"
								icon="edit_location"
								@click="goToDetails(room)"
								color="primary"
							/>
							&nbsp;{{ room.firstname }} {{ room.lastname }}
						</div>
					</div>
				</div>
			</q-card-section>
			<q-card-section
				v-if="room.facilities && roomSettings.facility"
				class="full-width row wrap justify-center items-start content-center"
			>
				<div>{{$t('room.facilities')}}:</div>
				<q-img
					class="icon"
					:src="facilitie.filename"
					v-for="facilitie in room.facilities"
					:key="facilitie.id"
				/>
			</q-card-section>
			<q-card-section
				class="text-center"
				v-if="(room.heartRate || room.bp_upper || room.saturation || room.vegi || room.vegan) && roomSettings.vitals"
			>
				<div>{{$t('room.patientVitals')}}:</div>
				<div
					v-if="room.heartRate && roomSettings.heartRate"
				>{{ $t('room.heartRate') }}: {{ room.heartRate }}</div>
				<div
					v-if="room.bp_upper && room.bp_lower && roomSettings.bp"
				>{{ $t('room.bp') }}: {{ room.bp_upper }}/{{ room.bp_lower }}</div>
				<div
					v-if="room.saturation && roomSettings.saturation"
				>{{ $t('room.saturation') }}: {{ room.saturation }}</div>
			</q-card-section>
			<q-card-section v-if="room.actions && roomSettings.actions && room.actions.length > 0">
				<span v-if="$i18n.locale === 'en'">{{room.actions[0].name_en}}</span>
				<span v-if="$i18n.locale === 'nl'">{{room.actions[0].name_nl}}</span>
				:&nbsp;{{calcTimeUntilAction(room.actions[0].dateTime)}}
				<div class="text-center">
					<q-btn
						:dense="roomSettings.dense"
						ripple
						flat
						:label="$t('room.actions')"
						class="bg-primary"
						@click="goToDetails(room)"
					/>
				</div>
			</q-card-section>
		</q-card>
		<div v-if="soundAlarm && !forceMuteAlarm">
			<audio loop autoplay v-bind:volume="volume">
				<source src="http://localhost:3000/buzz.mp3" type="audio/mp3" />
				<!-- todo fix audo volume -->
			</audio>
		</div>
	</div>
</template>

<script>
	import { eventBus } from "../js/event.js";
	import fetchFn from "../js/fetch";
	export default {
		name: "roomMap",
		data() {
			return {
				room: [],
				actions: [],
				APIURL: undefined,
				soundAlarm: false,
				forceMuteAlarm: false,
				volume: 0.5,
				loadDataInterval: "",
				calledForHelp: false,
				isDoctor: false,
				showCompleted: false,
				modified: false,
				modifierRunning: false,
				addActionprompt: false,
				newAction: {},
				roomSettings: {
					dense: false,
					roomNumber: true,
					facility: true,
					patient: true,
					patientPicture: true,
					vitals: true,
					actions: true,
					vegi: true,
					vegan: true,
					alarm: true,
					heartRate: true,
					hearRate_upper: 180,
					hearRate_lower: 50,
					bp: true,
					bp_upper_1: 200,
					bp_upper_2: 130,
					bp_lower_1: 100,
					bp_lower_2: 60,
					saturation: true,
					saturation_upper: 100,
					saturation_lower: 95,
					nextActionMinutes: 120
				}
			};
		},
		props: {
			roomId: {
				type: String,
				required: true
			},
			mapHeightFactor: {
				type: Number,
				required: true
			}
		},
		created() {
			eventBus.$on("volumeChanged", vol => {
				this.volume = vol / 10;
			});
			this.clearNewAction();
			this.loadRoomData();
			this.asncOnCreated();

			// room UI settings
			if (this.$q.cookies.has("roomUISettings")) {
				this.roomSettings = this.$q.cookies.get("roomUISettings");
			}
			eventBus.$on("roomUISettings", token => {
				if (token) {
					this.roomSettings = this.$q.cookies.get("roomUISettings");
				}
			});

			this.APIURL = fetchFn.getAPIURL();
			this.loadDataInterval = setInterval(this.loadRoomData, 2000);
		},
		destroyed() {
			clearInterval(this.loadDataInterval);
		},

		computed: {
			generateStyle() {
				let style = "";
				if (this.room.firstname) {
					style = "background: green;";
				}
				if (this.room.actions) {
					let uncompletedActions = this.room.actions.filter(
						action => !action.done
					);

					if (uncompletedActions.length > 0) {
						let soonestActionDateTime = uncompletedActions[0].dateTime;

						let timeUntil = this.calcTimeUntilAction(
							soonestActionDateTime,
							"array"
						);
						let minutes =
							timeUntil[0] * 24 * 60 +
							timeUntil[1] * 60 +
							timeUntil[2];

						if (timeUntil[0] === -1) {
							style = "background: #ff6600;";
						}
						if (this.roomSettings.nextActionMinutes > minutes) {
							style = "background: #ffae00;";
						}
					}
				}
				if (this.room.calledForHelp === true) {
					style = "background: #ff0000;";
				}
				if (this.soundAlarm === true) {
					style =
						"background-color: #ff0000;animation-name: redPulse;animation-duration: 2s;animation-iteration-count: infinite;";
				}
				style += `height: ${Math.floor(
					this.room.height * this.mapHeightFactor
				)} px;`;
				return style;
			}
		},
		methods: {
			calcTimeUntilAction(dateTime, mode = "normal") {
				let today = new Date();
				let date = new Date(dateTime);
				let diffMs = date - today;
				if (diffMs < 0) {
					if (mode === "normal") {
						return this.$i18n.t("error.timePassed");
					} else {
						return [-1, -1, -1];
					}
				}
				let diffDays = Math.floor(diffMs / 86400000);
				let diffHrs = Math.floor((diffMs % 86400000) / 3600000);
				let diffMins = Math.round(((diffMs % 86400000) % 3600000) / 60000);
				if (mode === "normal") {
					let string = "";
					if (diffDays > 0) {
						string =
							string +
							diffDays +
							" " +
							this.$i18n.t("time.days") +
							" ";
					}
					if (diffHrs > 0) {
						string =
							string +
							diffHrs +
							" " +
							this.$i18n.t("time.hours") +
							" ";
					}
					if (diffMins > 0) {
						string =
							string + diffMins + " " + this.$i18n.t("time.minutes");
					}
					return string;
				} else if (mode === "array") {
					return [diffDays, diffHrs, diffMins];
				}
			},
			clearNewAction() {
				this.newAction = {
					id: "",
					typeId: "",
					typeName_en: "",
					typeName_nl: "",
					date: "2020/01/01",
					time: "07:00",
					dateTime: "",
					done: undefined,
					note: ""
				};
			},
			goToDetails(room) {
				this.$router.push({
					name: "patient",
					params: { id: room.patientId }
				});
			},
			async asncOnCreated() {
				this.actions = await fetchFn.getActions();
				try {
					this.isDoctor = await fetchFn.isDoctor(
						this.$q.cookies.get("loginToken")
					);
				} catch (e) {
					this.isDoctor = false;
				}
			},
			async updateRoomData(room) {
				if (this.modifierRunning === true) return;
				this.modifierRunning = true;
				try {
					let patient = await fetchFn.getPatientById(
						this.$q.cookies.get("loginToken"),
						room.patientId
					);

					for (
						let i = 0;
						i < room.actions.length - patient.actions.length;
						i++
					) {
						patient.actions.push({
							id: "",
							typeId: "",
							dateTime: "",
							done: false,
							note: ""
						});
					}

					for (let i = 0; i < patient.actions.length; i++) {
						const patientAction = patient.actions[i];
						const modifiedAction = room.actions[i];
						Object.keys(patientAction).forEach(key => {
							patientAction[key] = modifiedAction[key];
						});
					}

					await fetchFn.putPatient(patient);
					this.modified = false;
				} catch (e) {
					this.$alert(
						this.$i18n.t("error.unexpected"),
						this.$i18n.t("error.error"),
						"error"
					);
				}
				this.modifierRunning = false;
			},
			async loadRoomData() {
				if (this.modified) {
					this.updateRoomData(this.room); // first update any changes to the actions
					return;
				}

				let tempRoom = await fetchFn.loadRoomData(
					this.$q.cookies.get("loginToken"),
					this.roomId
				);

				if (tempRoom.actions) {
					for (let j = 0; j < tempRoom.actions.length; j++) {
						const roomAction = tempRoom.actions[j];

						for (let i = 0; i < this.actions.length; i++) {
							const toCombineAction = this.actions[i];
							if (roomAction.typeId === toCombineAction.id) {
								Object.keys(toCombineAction).forEach(key => {
									return (roomAction[key] = toCombineAction[key]);
								});
							}
						}
					}
					tempRoom.actions.sort((a, b) =>
						a.dateTime.localeCompare(b.dateTime)
					);
					tempRoom.actionsOriginal = {
						...tempRoom.actions,
						original: true
					};
				}

				if (tempRoom.facilities && this.APIURL) {
					for (let i = 0; i < tempRoom.facilities.length; i++) {
						const roomFacil = tempRoom.facilities[i];
						if (roomFacil) {
							const facilitie = await fetchFn.getFacilitie(
								roomFacil.id
							);

							Object.keys(facilitie).forEach(key => {
								if (key === "filename") {
									return (roomFacil[key] =
										this.APIURL + "/" + facilitie[key]);
								} else {
									return (roomFacil[key] = facilitie[key]);
								}
							});
						}
					}
				}

				this.room = tempRoom;

				if (
					this.room.heartRate > this.roomSettings.hearRate_upper ||
					this.room.heartRate < this.roomSettings.hearRate_lower
				) {
					this.soundAlarm = true;
				} else if (
					this.room.bp_upper > this.roomSettings.bp_upper_1 ||
					this.room.bp_upper < this.roomSettings.bp_lower_1
				) {
					this.soundAlarm = true;
				} else if (
					this.room.bp_lower > this.roomSettings.bp_upper_2 ||
					this.room.bp_lower < this.roomSettings.bp_lower_2
				) {
					this.soundAlarm = true;
				} else if (
					this.room.saturation < this.roomSettings.saturation_lower ||
					this.room.saturation > this.roomSettings.saturation_upper
				) {
					this.soundAlarm = true;
				} else {
					this.soundAlarm = false;
				}
			}
		}
	};
</script>

<style>
	@keyframes redPulse {
		0% {
			background-color: #ff0000;
		}
		50% {
			background-color: #ff6600;
		}
		100% {
			background-color: #ff0000;
		}
	}
</style>

<style scoped>
	.cardPadding {
		padding: 0.1em;
	}
	.title {
		text-decoration: underline;
		font-weight: bold;
	}
	.icon {
		max-width: 1.5em;
		max-height: 1.5em;
		overflow: auto;
		margin: 1px;
	}
</style>
